/*
 *  alky.h
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#ifndef __ALKY_ALKY_H__
#define __ALKY_ALKY_H__

#include <stdio.h>
#include <stdlib.h>

#define AlkyLog(msg, args...) printf("AlkyLog: " msg "\n", ##args)
// #define AlkyLog(msg, args...) 
#define VSTUB(name, args) ALKYAPI void name##_W32 args { AlkyLog("Stub " #name " hit."); }
#define STUB(ret_type, name, args, ret) ALKYAPI ret_type name##_W32 args { AlkyLog("Stub " #name " hit."); return (ret); }

#ifdef __APPLE__
#define MAC   __APPLE__
#endif

#ifdef __linux__
#define LINUX __linux__
#endif

#define STDCALL __attribute__((stdcall))
#define CDECL __attribute__((cdecl))
#ifdef MAC
#define REALIGN __attribute__((force_align_arg_pointer))
#else
#define REALIGN
#endif
#define ALKYAPI STDCALL REALIGN
#define ALKY_C_API REALIGN

#include "typedefs.h"
#include "com.h"
#include "Kernel32/Kernel32.h"
#include "User32/User32.h"
#include "Internal/Internal.h"
#include "DirectX/D3D9/D3D9.h"
#include "DirectX/D3DGL/D3DGL.h"

#ifdef MAC
#include <OpenGL/gl.h>
#else
#include <GL/gl.h>
#endif

HWND ActiveWindow;

#endif
