/*
 *  com.h
 *  LibAlky
 *
 *  Created by Cody Brocious on 6/6/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#ifndef __ALKY_COM_H__
#define __ALKY_COM_H__

#define CLASS(name, struct_, vtable) \
struct STRUCT_##name##_s { struct_ } typedef STRUCT_##name; \
void *VTABLE_##name[] = { NULL, vtable };

#define STRUCT(st...) st
#define VTABLE(vt...) vt
#define CMEMBER(name) (void *) name##_W32
#define CSTUB(name) (void *) UnsupportedFunction

#define INIT_CLASS(name, var) \
do { \
  var = (void *) malloc(sizeof(VTABLE_##name)); \
  memcpy(var, VTABLE_##name, sizeof(VTABLE_##name)); \
  if(sizeof(STRUCT_##name) > 0) { \
    ((void **) var)[0] = (void *) malloc(sizeof(STRUCT_##name)); \
    memset(((void **) var)[0], 0, sizeof(STRUCT_##name)); \
  } \
  var = (void *) (&((void **) var)[1]); \
} while(0);

#define INIT_CLASS_WITH_STRUCT(name, svar, var) \
do { \
  var = (void *) malloc(sizeof(VTABLE_##name)); \
  memcpy(var, VTABLE_##name, sizeof(VTABLE_##name)); \
  if(sizeof(STRUCT_##name) > 0) { \
    svar = ((void **) var)[0] = (void *) malloc(sizeof(STRUCT_##name)); \
    memset(svar, 0, sizeof(STRUCT_##name)); \
  } \
  var = (void *) (&((void **) var)[1]); \
  memset(svar, 0, sizeof(STRUCT_##name)); \
} while(0);

#define GET_CLASS_STRUCT(name, obj) \
((STRUCT_##name *) ((void **) obj)[-1])

#endif
