/*
 *  typedefs.h
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#define CONST const

// simple types
typedef unsigned	short	WORD;			// word/dword
typedef unsigned	long	DWORD;
typedef 		short int 	*LPWORD;
typedef signed		char	TCHAR;			// tchar/wchar/u_char
typedef unsigned 	short	WCHAR;
typedef unsigned 	int 	BOOL;			// bool
typedef 			BOOL 	*LPBOOL;
typedef unsigned 	char 	BYTE;			// byte
typedef 			BYTE	*LPBYTE;
typedef 			int		INT;			// int
typedef unsigned 	int 	UINT;
typedef 			UINT	*PUINT;
typedef 			int 	__int32;
typedef 			DWORD	LONG;			// long
typedef 			int		*PLONG;
typedef 			int		*LPLONG;
typedef unsigned 	int 	*ULONG_PTR;
typedef 			void	*PVOID;			// void
typedef 			void	*LPVOID;
typedef 			void	*LPCVOID;
typedef 			UINT 	u_int;
typedef unsigned 	char 	u_char;
typedef unsigned 	short	u_short;
typedef unsigned 	long 	u_long;
typedef 			DWORD	SIZE_T;			// size_t
typedef 			long long LONGLONG;		// long long
typedef unsigned	long long ULONGLONG;


// strings
typedef char	*LPSTR;		// cstring
typedef char	*LPCSTR;	// const cstring
typedef TCHAR	*LPTSTR;	// tchar string
typedef TCHAR	*LPCTSTR;	// const tchar string
typedef WCHAR	*LPWSTR;	// wchar_t string
typedef WCHAR	*LPCWSTR;	// const wchar_t string


// DWORD pointers (both are long pointers.. what should PDWORD be normally?)
typedef DWORD *PDWORD;
typedef DWORD *LPDWORD;


// registry types
typedef void *HKEY;
typedef HKEY *PHKEY;		// nice double pointer :'(
typedef int	 REGSAM;


// "H" return types
typedef void	*HMODULE;
typedef LPVOID	HANDLE;
typedef DWORD	HRESULT;
typedef HANDLE	*LPHANDLE;
typedef void 	*HIMAGELIST;
typedef void 	*HINSTANCE;
typedef void 	*HLOCAL;
typedef void	*HGDIOBJ;


// threading
typedef void *LPTHREAD_START_ROUTINE;


// other stuff
typedef void	*PROC;
typedef void	*FARPROC;
typedef void	*LPCRITICAL_SECTION;
typedef DWORD	LCID;
typedef DWORD	LCTYPE;
typedef DWORD 	COLORREF;
typedef DWORD 	*LPCOLORREF;
typedef void 	*LPTOP_LEVEL_EXCEPTION_FILTER;
typedef void 	*LOCALE_ENUMPROCA;



typedef struct _FILETIME {
  DWORD dwLowDateTime;
  DWORD dwHighDateTime;
} FILETIME;
typedef FILETIME *LPFILETIME;

typedef struct _SYSTEMTIME {
  WORD wYear;
  WORD wMonth;
  WORD wDayOfWeek;
  WORD wDay;
  WORD wHour;
  WORD wMinute;
  WORD wSecond;
  WORD wMilliseconds;
} SYSTEMTIME,
*LPSYSTEMTIME;

typedef struct _TIME_ZONE_INFORMATION {
  LONG Bias;
  WCHAR StandardName[32];
  SYSTEMTIME StandardDate;
  LONG StandardBias;
  WCHAR DaylightName[32];
  SYSTEMTIME DaylightDate;
  LONG DaylightBias;
} TIME_ZONE_INFORMATION;
typedef TIME_ZONE_INFORMATION *LPTIME_ZONE_INFORMATION;

typedef struct _SECURITY_ATTRIBUTES {
  DWORD nLength;
  LPVOID lpSecurityDescriptor;
  BOOL bInheritHandle;
} SECURITY_ATTRIBUTES, 
*PSECURITY_ATTRIBUTES;
typedef SECURITY_ATTRIBUTES LPSECURITY_ATTRIBUTES;

typedef struct _SYSTEM_INFO {
  union {
    DWORD dwOemId;
    struct {
      WORD wProcessorArchitecture;
      WORD wReserved;
    };
  };
  DWORD dwPageSize;
  LPVOID lpMinimumApplicationAddress;
  LPVOID lpMaximumApplicationAddress;
  LPDWORD dwActiveProcessorMask;
  DWORD dwNumberOfProcessors;
  DWORD dwProcessorType;
  DWORD dwAllocationGranularity;
  WORD wProcessorLevel;
  WORD wProcessorRevision;
} SYSTEM_INFO;
typedef SYSTEM_INFO LPSYSTEM_INFO;

typedef struct _STARTUPINFO {
  DWORD cb;
  LPCSTR lpReserved;
  LPCSTR lpDesktop;
  LPCSTR lpTitle;
  DWORD dwX;
  DWORD dwY;
  DWORD dwXSize;
  DWORD dwYSize;
  DWORD dwXCountChars;
  DWORD dwYCountChars;
  DWORD dwFillAttribute;
  DWORD dwFlags;
  WORD wShowWindow;
  WORD cbReserved2;
  LPBYTE lpReserved2;
  HANDLE hStdInput;
  HANDLE hStdOutput;
  HANDLE hStdError;
} STARTUPINFO, 
*LPSTARTUPINFOA;

typedef struct _OVERLAPPED {
  ULONG_PTR Internal;
  ULONG_PTR InternalHigh;
  union {
    struct {
      DWORD Offset;
      DWORD OffsetHigh;
    };
    PVOID Pointer;
  };
  HANDLE hEvent;
} OVERLAPPED,
*LPOVERLAPPED;

typedef struct _MEMORYSTATUS { 
  DWORD dwLength; 
  DWORD dwMemoryLoad; 
  DWORD dwTotalPhys; 
  DWORD dwAvailPhys; 
  DWORD dwTotalPageFile; 
  DWORD dwAvailPageFile; 
  DWORD dwTotalVirtual; 
  DWORD dwAvailVirtual; 
} MEMORYSTATUS, *LPMEMORYSTATUS;

#define MAX_PATH 256

typedef struct _WIN32_FIND_DATA {
  DWORD dwFileAttributes;
  FILETIME ftCreationTime;
  FILETIME ftLastAccessTime;
  FILETIME ftLastWriteTime;
  DWORD nFileSizeHigh;
  DWORD nFileSizeLow;
  DWORD dwReserved0;
  DWORD dwReserved1;
  TCHAR cFileName[MAX_PATH];
  TCHAR cAlternateFileName[14];
} WIN32_FIND_DATA, 
*PWIN32_FIND_DATAA, 
*LPWIN32_FIND_DATAA;

typedef union _LARGE_INTEGER {
  struct {
    DWORD LowPart;
    LONG HighPart;
  };
  struct {
    DWORD LowPart;
    LONG HighPart;
  } u;
  LONGLONG QuadPart;
} LARGE_INTEGER, 
*PLARGE_INTEGER;

typedef struct tagINITCOMMONCONTROLSEX {
  DWORD dwSize;
  DWORD dwICC;
} INITCOMMONCONTROLSEX, *LPINITCOMMONCONTROLSEX;

typedef enum _GET_FILEEX_INFO_LEVELS { 
  GetFileExInfoStandard 
} GET_FILEEX_INFO_LEVELS; 

typedef struct _OSVERSIONINFOEXA {
  DWORD dwOSVersionInfoSize;
  DWORD dwMajorVersion;
  DWORD dwMinorVersion;
  DWORD dwBuildNumber;
  DWORD dwPlatformId;
  TCHAR szCSDVersion[128];
  WORD wServicePackMajor;
  WORD wServicePackMinor;
  WORD wSuiteMask;
  BYTE wProductType;
  BYTE wReserved;
} OSVERSIONINFOEXA, 
*POSVERSIONINFOEXA,
*LPOSVERSIONINFOEXA;

#define MAX_DEFAULTCHAR 2
#define MAX_LEADBYTES 12

typedef struct _cpinfo { 
  UINT MaxCharSize; 
  BYTE DefaultChar[MAX_DEFAULTCHAR]; 
  BYTE LeadByte[MAX_LEADBYTES]; 
} CPINFO, *LPCPINFO;

typedef struct _MEMORY_BASIC_INFORMATION {
  PVOID BaseAddress;
  PVOID AllocationBase;
  DWORD AllocationProtect;
  SIZE_T RegionSize;
  DWORD State;
  DWORD Protect;
  DWORD Type;
} MEMORY_BASIC_INFORMATION, 
*PMEMORY_BASIC_INFORMATION;

#define EXCEPTION_MAXIMUM_PARAMETERS 15

typedef struct _EXCEPTION_RECORD {
  DWORD ExceptionCode;
  DWORD ExceptionFlags;
  struct _EXCEPTION_RECORD* ExceptionRecord;
  PVOID ExceptionAddress;
  DWORD NumberParameters;
  ULONG_PTR ExceptionInformation[EXCEPTION_MAXIMUM_PARAMETERS];
} EXCEPTION_RECORD, 
*PEXCEPTION_RECORD;


typedef struct _CONTEXT {
  
  //
  // This section is specified/returned if the ContextFlags word contains
  // the flag CONTEXT_FLOATING_POINT.
  //
  
  ULONGLONG FltF0;
  ULONGLONG FltF1;
  ULONGLONG FltF2;
  ULONGLONG FltF3;
  ULONGLONG FltF4;
  ULONGLONG FltF5;
  ULONGLONG FltF6;
  ULONGLONG FltF7;
  ULONGLONG FltF8;
  ULONGLONG FltF9;
  ULONGLONG FltF10;
  ULONGLONG FltF11;
  ULONGLONG FltF12;
  ULONGLONG FltF13;
  ULONGLONG FltF14;
  ULONGLONG FltF15;
  ULONGLONG FltF16;
  ULONGLONG FltF17;
  ULONGLONG FltF18;
  ULONGLONG FltF19;
  ULONGLONG FltF20;
  ULONGLONG FltF21;
  ULONGLONG FltF22;
  ULONGLONG FltF23;
  ULONGLONG FltF24;
  ULONGLONG FltF25;
  ULONGLONG FltF26;
  ULONGLONG FltF27;
  ULONGLONG FltF28;
  ULONGLONG FltF29;
  ULONGLONG FltF30;
  ULONGLONG FltF31;
  
  //
  // This section is specified/returned if the ContextFlags word contains
  // the flag CONTEXT_INTEGER.
  //
  // N.B. The registers gp, sp, and ra are defined in this section, but are
  //  considered part of the control context rather than part of the integer
  //  context.
  //
  
  ULONGLONG IntV0;    //  $0: return value register, v0
  ULONGLONG IntT0;    //  $1: temporary registers, t0 - t7
  ULONGLONG IntT1;    //  $2:
  ULONGLONG IntT2;    //  $3:
  ULONGLONG IntT3;    //  $4:
  ULONGLONG IntT4;    //  $5:
  ULONGLONG IntT5;    //  $6:
  ULONGLONG IntT6;    //  $7:
  ULONGLONG IntT7;    //  $8:
  ULONGLONG IntS0;    //  $9: nonvolatile registers, s0 - s5
  ULONGLONG IntS1;    // $10:
  ULONGLONG IntS2;    // $11:
  ULONGLONG IntS3;    // $12:
  ULONGLONG IntS4;    // $13:
  ULONGLONG IntS5;    // $14:
  ULONGLONG IntFp;    // $15: frame pointer register, fp/s6
  ULONGLONG IntA0;    // $16: argument registers, a0 - a5
  ULONGLONG IntA1;    // $17:
  ULONGLONG IntA2;    // $18:
  ULONGLONG IntA3;    // $19:
  ULONGLONG IntA4;    // $20:
  ULONGLONG IntA5;    // $21:
  ULONGLONG IntT8;    // $22: temporary registers, t8 - t11
  ULONGLONG IntT9;    // $23:
  ULONGLONG IntT10;   // $24:
  ULONGLONG IntT11;   // $25:
  ULONGLONG IntRa;    // $26: return address register, ra
  ULONGLONG IntT12;   // $27: temporary register, t12
  ULONGLONG IntAt;    // $28: assembler temp register, at
  ULONGLONG IntGp;    // $29: global pointer register, gp
  ULONGLONG IntSp;    // $30: stack pointer register, sp
  ULONGLONG IntZero;  // $31: zero register, zero
  
  //
  // This section is specified/returned if the ContextFlags word contains
  // the flag CONTEXT_FLOATING_POINT.
  //
  
  ULONGLONG Fpcr;     // floating point control register
  ULONGLONG SoftFpcr; // software extension to FPCR
  
  //
  // This section is specified/returned if the ContextFlags word contains
  // the flag CONTEXT_CONTROL.
  //
  // N.B. The registers gp, sp, and ra are defined in the integer section,
  //   but are considered part of the control context rather than part of
  //   the integer context.
  //
  
  ULONGLONG Fir;      // (fault instruction) continuation address
  DWORD Psr;          // processor status
  
  //
  // The flags values within this flag control the contents of
  // a CONTEXT record.
  //
  // If the context record is used as an input parameter, then
  // for each portion of the context record controlled by a flag
  // whose value is set, it is assumed that that portion of the
  // context record contains valid context. If the context record
  // is being used to modify a thread's context, then only that
  // portion of the threads context will be modified.
  //
  // If the context record is used as an IN OUT parameter to capture
  // the context of a thread, then only those portions of the thread's
  // context corresponding to set flags will be returned.
  //
  // The context record is never used as an OUT only parameter.
  //
  
  DWORD ContextFlags;
  DWORD Fill[4];      // padding for 16-byte stack frame alignment
  
} CONTEXT, *PCONTEXT;

typedef struct _EXCEPTION_POINTERS {
  PEXCEPTION_RECORD ExceptionRecord;
  PCONTEXT ContextRecord;
} EXCEPTION_POINTERS, 
*PEXCEPTION_POINTERS;
