/*
 *  D3D9_Device.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 6/8/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "D3D9_Device.h"

ALKYAPI HRESULT IDirect3DDevice9_SetTransform_W32(
                                                  void *IDirect3DDevice9,
                                                  D3DTransformStateType type,
                                                  D3DXMatrix *mat
                                                  ) {
  AlkyLog("IDirect3DDevice9::SetTransform called");
  
  return D3DSetTransformProc(type, (D3DMatrix *) mat);
}

ALKYAPI HRESULT IDirect3DDevice9_SetRenderState_W32(
                                                void *IDirect3DDevice9,
                                                D3DRenderStateType type,
                                                DWORD value
                                                ) {
  AlkyLog("IDirect3DDevice9::SetRenderState called");
  
  return D3DSetRenderStateProc(type, value);
}

ALKYAPI HRESULT IDirect3DDevice9_SetSamplerState_W32(
                                                 void *IDirect3DDevice9,
                                                 int sampler,
                                                 D3DSamplerStateType type,
                                                 DWORD value
                                                 ) {
  AlkyLog("IDirect3DDevice9::SetSamplerState called");
  
  return D3DSetSamplerStateProc(sampler, type, value);
}

ALKYAPI HRESULT IDirect3DDevice9_SetFVF_W32(
                                            void *IDirect3DDevice9,
                                            DWORD fvf
                                            ) {
  AlkyLog("IDirect3DDevice9::SetFVF called");
  
  return D3DSetFVFProc(fvf);
}

#define __DEF_CLASS__
#include "D3D9_Device.h"

ALKYAPI HRESULT Direct3D9_CreateDevice_W32(
                                           void *IDirect3D9,
                                           UINT Adapter,
                                           D3DDEVTYPE DeviceType,
                                           HWND hFocusWindow,
                                           DWORD BehaviorFlags,
                                           D3DPresentationParameters * params,
                                           void ** ppReturnedDeviceInterface
                                           ) {
  void *IDObj, **Ref;
  
  AlkyLog("IDirect3D9::CreateDevice called");
  
  INIT_CLASS(IDirect3DDevice9, IDObj);

  Ref = (void **) malloc(sizeof(void *));
  *Ref = IDObj;
  *ppReturnedDeviceInterface = Ref;
  
  D3DGLInitWindowed(hFocusWindow, params);
  
  return TRUE;
}

