/*
 *  D3D9_Device.h
 *  LibAlky
 *
 *  Created by Cody Brocious on 6/8/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#ifndef __ALKY_D3D9_DEVICE_H__
#define __ALKY_D3D9_DEVICE_H__

#include "D3D9.h"

ALKYAPI HRESULT Direct3D9_CreateDevice_W32(
                                           void *IDirect3D9,
                                           UINT Adapter,
                                           D3DDEVTYPE DeviceType,
                                           HWND hFocusWindow,
                                           DWORD BehaviorFlags,
                                           D3DPresentationParameters * pPresentationParameters,
                                           void ** ppReturnedDeviceInterface
                                           );

#endif

#ifdef __DEF_CLASS__
CLASS(IDirect3DDevice9,
      STRUCT(),
      VTABLE(
             CSTUB(IDirect3DDevice9_QueryInterface), /* 0000 */
             CSTUB(IDirect3DDevice9_AddRef), /* 0004 */
             CSTUB(IDirect3DDevice9_Release), /* 0008 */
             CSTUB(IDirect3DDevice9_TestCooperativeLevel), /* 000c */
             CSTUB(IDirect3DDevice9_GetAvailableTextureMem), /* 0010 */
             CSTUB(IDirect3DDevice9_EvictManagedResources), /* 0014 */
             CSTUB(IDirect3DDevice9_GetDirect3D), /* 0018 */
             CSTUB(IDirect3DDevice9_GetDeviceCaps), /* 001c */
             CSTUB(IDirect3DDevice9_GetDisplayMode), /* 0020 */
             CSTUB(IDirect3DDevice9_GetCreationParameters), /* 0024 */
             CSTUB(IDirect3DDevice9_SetCursorProperties), /* 0028 */
             CSTUB(IDirect3DDevice9_SetCursorPosition), /* 002c */
             CSTUB(IDirect3DDevice9_ShowCursor), /* 0030 */
             CSTUB(IDirect3DDevice9_CreateAdditionalSwapChain), /* 0034 */
             CSTUB(IDirect3DDevice9_GetSwapChain), /* 0038 */
             CSTUB(IDirect3DDevice9_GetNumberOfSwapChains), /* 003c */
             CSTUB(IDirect3DDevice9_Reset), /* 0040 */
             CSTUB(IDirect3DDevice9_Present), /* 0044 */
             CSTUB(IDirect3DDevice9_GetBackBuffer), /* 0048 */
             CSTUB(IDirect3DDevice9_GetRasterStatus), /* 004c */
             CSTUB(IDirect3DDevice9_SetDialogBoxMode), /* 0050 */
             CSTUB(IDirect3DDevice9_SetGammaRamp), /* 0054 */
             CSTUB(IDirect3DDevice9_GetGammaRamp), /* 0058 */
             CSTUB(IDirect3DDevice9_CreateTexture), /* 005c */
             CSTUB(IDirect3DDevice9_CreateVolumeTexture), /* 0060 */
             CSTUB(IDirect3DDevice9_CreateCubeTexture), /* 0064 */
             CMEMBER(IDirect3DDevice9_CreateVertexBuffer), /* 0068 */
             CSTUB(IDirect3DDevice9_CreateIndexBuffer), /* 006c */
             CSTUB(IDirect3DDevice9_CreateRenderTarget), /* 0070 */
             CSTUB(IDirect3DDevice9_CreateDepthStencilSurface), /* 0074 */
             CSTUB(IDirect3DDevice9_UpdateSurface), /* 0078 */
             CSTUB(IDirect3DDevice9_UpdateTexture), /* 007c */
             CSTUB(IDirect3DDevice9_GetRenderTargetData), /* 0080 */
             CSTUB(IDirect3DDevice9_GetFrontBufferData), /* 0084 */
             CSTUB(IDirect3DDevice9_StretchRect), /* 0088 */
             CSTUB(IDirect3DDevice9_ColorFill), /* 008c */
             CSTUB(IDirect3DDevice9_CreateOffscreenPlainSurface), /* 0090 */
             CSTUB(IDirect3DDevice9_SetRenderTarget), /* 0094 */
             CSTUB(IDirect3DDevice9_GetRenderTarget), /* 0098 */
             CSTUB(IDirect3DDevice9_SetDepthStencilSurface), /* 009c */
             CSTUB(IDirect3DDevice9_GetDepthStencilSurface), /* 00a0 */
             CSTUB(IDirect3DDevice9_BeginScene), /* 00a4 */
             CSTUB(IDirect3DDevice9_EndScene), /* 00a8 */
             CSTUB(IDirect3DDevice9_Clear), /* 00ac */
             CMEMBER(IDirect3DDevice9_SetTransform), /* 00b0 */
             CSTUB(IDirect3DDevice9_GetTransform), /* 00b4 */
             CSTUB(IDirect3DDevice9_MultiplyTransform), /* 00b8 */
             CSTUB(IDirect3DDevice9_SetViewport), /* 00bc */
             CSTUB(IDirect3DDevice9_GetViewport), /* 00c0 */
             CSTUB(IDirect3DDevice9_SetMaterial), /* 00c4 */
             CSTUB(IDirect3DDevice9_GetMaterial), /* 00c8 */
             CSTUB(IDirect3DDevice9_SetLight), /* 00cc */
             CSTUB(IDirect3DDevice9_GetLight), /* 00d0 */
             CSTUB(IDirect3DDevice9_LightEnable), /* 00d4 */
             CSTUB(IDirect3DDevice9_GetLightEnable), /* 00d8 */
             CSTUB(IDirect3DDevice9_SetClipPlane), /* 00dc */
             CSTUB(IDirect3DDevice9_GetClipPlane), /* 00e0 */
             CMEMBER(IDirect3DDevice9_SetRenderState), /* 00e4 */
             CSTUB(IDirect3DDevice9_GetRenderState), /* 00e8 */
             CSTUB(IDirect3DDevice9_CreateStateBlock), /* 00ec */
             CSTUB(IDirect3DDevice9_BeginStateBlock), /* 00f0 */
             CSTUB(IDirect3DDevice9_EndStateBlock), /* 00f4 */
             CSTUB(IDirect3DDevice9_SetClipStatus), /* 00f8 */
             CSTUB(IDirect3DDevice9_GetClipStatus), /* 00fc */
             CSTUB(IDirect3DDevice9_GetTexture), /* 0100 */
             CSTUB(IDirect3DDevice9_SetTexture), /* 0104 */
             CSTUB(IDirect3DDevice9_GetTextureStageState), /* 0108 */
             CSTUB(IDirect3DDevice9_SetTextureStageState), /* 010c */
             CSTUB(IDirect3DDevice9_GetSamplerState), /* 0110 */
             CMEMBER(IDirect3DDevice9_SetSamplerState), /* 0114 */
             CSTUB(IDirect3DDevice9_ValidateDevice), /* 0118 */
             CSTUB(IDirect3DDevice9_SetPaletteEntries), /* 011c */
             CSTUB(IDirect3DDevice9_GetPaletteEntries), /* 0120 */
             CSTUB(IDirect3DDevice9_SetCurrentTexturePalette), /* 0124 */
             CSTUB(IDirect3DDevice9_GetCurrentTexturePalette), /* 0128 */
             CSTUB(IDirect3DDevice9_SetScissorRect), /* 012c */
             CSTUB(IDirect3DDevice9_GetScissorRect), /* 0130 */
             CSTUB(IDirect3DDevice9_SetSoftwareVertexProcessing), /* 0134 */
             CSTUB(IDirect3DDevice9_GetSoftwareVertexProcessing), /* 0138 */
             CSTUB(IDirect3DDevice9_SetNPatchMode), /* 013c */
             CSTUB(IDirect3DDevice9_GetNPatchMode), /* 0140 */
             CSTUB(IDirect3DDevice9_DrawPrimitive), /* 0144 */
             CSTUB(IDirect3DDevice9_DrawIndexedPrimitive), /* 0148 */
             CSTUB(IDirect3DDevice9_DrawPrimitiveUP), /* 014c */
             CSTUB(IDirect3DDevice9_DrawIndexedPrimitiveUP), /* 0150 */
             CSTUB(IDirect3DDevice9_ProcessVertices), /* 0154 */
             CSTUB(IDirect3DDevice9_CreateVertexDeclaration), /* 0158 */
             CSTUB(IDirect3DDevice9_SetVertexDeclaration), /* 015c */
             CSTUB(IDirect3DDevice9_GetVertexDeclaration), /* 0160 */
             CMEMBER(IDirect3DDevice9_SetFVF), /* 0164 */
             CSTUB(IDirect3DDevice9_GetFVF), /* 0168 */
             CSTUB(IDirect3DDevice9_CreateVertexShader), /* 016c */
             CSTUB(IDirect3DDevice9_SetVertexShader), /* 0170 */
             CSTUB(IDirect3DDevice9_GetVertexShader), /* 0174 */
             CSTUB(IDirect3DDevice9_SetVertexShaderConstantF), /* 0178 */
             CSTUB(IDirect3DDevice9_GetVertexShaderConstantF), /* 017c */
             CSTUB(IDirect3DDevice9_SetVertexShaderConstantI), /* 0180 */
             CSTUB(IDirect3DDevice9_GetVertexShaderConstantI), /* 0184 */
             CSTUB(IDirect3DDevice9_SetVertexShaderConstantB), /* 0188 */
             CSTUB(IDirect3DDevice9_GetVertexShaderConstantB), /* 018c */
             CSTUB(IDirect3DDevice9_SetStreamSource), /* 0190 */
             CSTUB(IDirect3DDevice9_GetStreamSource), /* 0194 */
             CSTUB(IDirect3DDevice9_SetStreamSourceFreq), /* 0198 */
             CSTUB(IDirect3DDevice9_GetStreamSourceFreq), /* 019c */
             CSTUB(IDirect3DDevice9_SetIndices), /* 01a0 */
             CSTUB(IDirect3DDevice9_GetIndices), /* 01a4 */
             CSTUB(IDirect3DDevice9_CreatePixelShader), /* 01a8 */
             CSTUB(IDirect3DDevice9_SetPixelShader), /* 01ac */
             CSTUB(IDirect3DDevice9_GetPixelShader), /* 01b0 */
             CSTUB(IDirect3DDevice9_SetPixelShaderConstantF), /* 01b4 */
             CSTUB(IDirect3DDevice9_GetPixelShaderConstantF), /* 01b8 */
             CSTUB(IDirect3DDevice9_SetPixelShaderConstantI), /* 01bc */
             CSTUB(IDirect3DDevice9_GetPixelShaderConstantI), /* 01c0 */
             CSTUB(IDirect3DDevice9_SetPixelShaderConstantB), /* 01c4 */
             CSTUB(IDirect3DDevice9_GetPixelShaderConstantB), /* 01c8 */
             CSTUB(IDirect3DDevice9_DrawRectPatch), /* 01cc */
             CSTUB(IDirect3DDevice9_DrawTriPatch), /* 01d0 */
             CSTUB(IDirect3DDevice9_DeletePatch), /* 01d4 */
             CSTUB(IDirect3DDevice9_CreateQuery) /* 01d8 */
             ));
#endif
