/*
 *  D3DX9.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 6/8/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "D3DX9.h"

ALKYAPI D3DXMatrix* D3DXMatrixPerspectiveFovLH_W32(D3DXMatrix *pOut,
                                                   float fovy, float aspect, float zNear, float zFar) {
  float f;
  
  AlkyLog("D3DXMatrixPerspectiveFovLH called");
  
  f = 1.0f / tan(fovy / 2.0f);
  
  memset(pOut, 0, sizeof(D3DXMatrix));
  
  pOut->m[0][0] = f / aspect;
  pOut->m[1][1] = f;
  pOut->m[2][2] = (zFar+zNear)/(zNear-zFar);
  pOut->m[2][3] = (2*zFar*zNear)/(zNear-zFar);
  pOut->m[3][2] = -1.0f;
  
  return pOut;
}
