/*
 *  Kernel32.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "Kernel32.h"

// 16-bit backwards compatability
// stated by MSDN that this is not necessary and does nothing, so, it does nothing.
ALKYAPI UINT SetHandleCount( UINT uNumber ) {
  return 0;
}

VSTUB(OutputDebugStringA, (LPCSTR lpOutputString));
VSTUB(Sleep, (DWORD dwMilliseconds));
VSTUB(GetSystemTime, (LPSYSTEMTIME lpSystemTime));
STUB(UINT, GetPrivateProfileIntA, (LPCSTR lpAppName,LPCSTR lpKeyName,INT nDefault,LPCSTR lpFileName), 0);
STUB(BOOL, WritePrivateProfileStringA, (LPCSTR lpAppName,LPCSTR lpKeyName,LPCSTR lpString,LPCSTR lpFileName), 0);
STUB(DWORD, GetPrivateProfileStringA, (LPCSTR lpAppName,LPCSTR lpKeyName,LPCSTR lpDefault,LPSTR lpReturnedString,DWORD nSize,LPCSTR lpFileName), 0);
STUB(DWORD, IsDebuggerPresent, (), 0);
STUB(UINT, GetDoubleClickTime, (), 0);
STUB(BOOL, SetStdHandle, (DWORD nStdHandle,HANDLE hHandle), 0);
STUB(BOOL, DuplicateHandle, (HANDLE hSourceProcessHandle,HANDLE hSourceHandle,HANDLE hTargetProcessHandle,LPHANDLE lpTargetHandle,DWORD dwDesiredAccess,BOOL bInheritHandle,DWORD dwOptions), 0);
STUB(HWND, GetForegroundWindow, (), 0);
STUB(BOOL, GetWindowRect, ( HWND hWnd, LPRECT lpRect ), 0);
STUB(BOOL, ClipCursor, ( const LPRECT lpRect), 0);
STUB(BOOL, SetRect, (LPRECT lprc, int xLeft, int yTop, int xRight, int yBottom), 0);
STUB(BOOL, OffsetRect, (LPRECT lprc, int dx, int dy), 0);

// STUB(UINT, SetHandleCount, (UINT uNumber), 0);
// VSTUB(ExitProcess, (UINT uExitCode));
// STUB(DWORD, GetTickCount, (), 0);
// STUB(DWORD, GetVersion, (), 0x00000000);
// STUB(BOOL, GetVersionExA, (LPOSVERSIONINFOA lpVersionInformation), 0);
// STUB(LPSTR, GetCommandLineA, (), (LPSTR) "Oblivion.exe");
// VSTUB(GetStartupInfoA, (LPSTARTUPINFOA lpStartupInfo));
// STUB(BOOL, SystemParametersInfoW, (UINT uiAction, UINT uiParam, PVOID pvParam, UINT fWinIni), 0);

/*
STUB(HRESULT, D3DXComputeNormals, (LPD3DXBASEMESH pMesh,CONST DWORD * pAdjacency), 0);
STUB(DWORD, GetFileAttributes, (LPCTSTR lpFileName), 0);
STUB(LONG, RegOpenKeyEx, (HKEY hKey, LPCTSTR lpSubKey, DWORD ulOptions, REGSAM samDesired, PHKEY phkResult), 0);
STUB(BOOL, IsDBCSLeadByteEx, (UINT CodePage,BYTE TestChar ), 0);
STUB(LRESULT, SendMessage, (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam ), 0);
STUB(BOOL, UnregisterClass, ( LPCTSTR lpClassName, HINSTANCE hInstance), 0);
STUB(int, GetDIBits, (HDC hdc, HBITMAP hbmp, UINT uStartScan, UINT cScanLines, LPVOID lpvBits, LPBITMAPINFO lpbi, UINT uUsage), 0);
STUB(D3DXMATRIX*, D3DXMatrixLookAtLH, (D3DXMATRIX* pOut,CONST D3DXVECTOR3* pEye,CONST D3DXVECTOR3* pAt,CONST D3DXVECTOR3* pUp), 0);
STUB(D3DXMATRIX *, D3DXMatrixRotationYawPitchRoll, (D3DXMATRIX * pOut,FLOAT Yaw,FLOAT Pitch,FLOAT Roll), 0);
STUB(HRESULT, D3DXCreateTextureFromResourceEx, (LPDIRECT3DDEVICE9 pDevice,HMODULE hSrcModule,LPCTSTR pSrcResource,UINT Width,UINT Height,UINT MipLevels,DWORD Usage,D3DFORMAT Format,D3DPOOL Pool,DWORD Filter,DWORD MipFilter,D3DCOLOR ColorKey,D3DXIMAGE_INFO * pSrcInfo,PALETTEENTRY * pPalette,LPDIRECT3DTEXTURE9 * ppTexture), 0);
STUB(int, DialogBoxIndirectParam, ( HINSTANCE hInstance, LPCDLGTEMPLATE hDialogTemplate, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam), 0);
STUB(DWORD, GetFullPathName, (LPCTSTR lpFileName, DWORD nBufferLength, LPTSTR lpBuffer, LPTSTR* lpFilePart), 0);
STUB(LONG, RegSetValueEx, ( HKEY hKey, LPCWSTR lpValueName, DWORD Reserved, DWORD dwType, const BYTE* lpData, DWORD cbData ), 0);
STUB(SHORT, GetKeyState, ( int nVirtKey ), 0);
STUB(D3DXMATRIX *, D3DXMatrixMultiplyTranspose, (D3DXMATRIX* pOut,CONST D3DXMATRIX* pM1,CONST D3DXMATRIX* pM2), 0);
STUB(D3DXMATRIX *, D3DXMatrixInverse, (D3DXMATRIX * pOut,FLOAT * pDeterminant,CONST D3DXMATRIX * pM), 0);
STUB(D3DXMATRIX *, D3DXMatrixRotationQuaternion, (D3DXMATRIX * pOut,CONST D3DXQUATERNION * pQ), 0);
STUB(DWORD , GetModuleFileName, (HMODULE hModule, LPTSTR lpFilename, DWORD nSize), 0);
STUB(HRESULT, D3DXLoadMeshHierarchyFromX, (LPCSTR Filename,DWORD MeshOptions,LPDIRECT3DDEVICE9 pDevice,LPD3DXALLOCATEHIERARCHY pAlloc,LPD3DXLOADUSERDATA pUserDataLoader,LPD3DXFRAME* ppFrameHierarchy,LPD3DXANIMATIONCONTROLLER* ppAnimController), 0);
STUB(int, GetWindowText, ( HWND hWnd, LPTSTR lpString, int nMaxCount ), 0);
STUB(HRESULT, D3DXCreateFontIndirect, (LPDIRECT3DDEVICE9 pDevice,CONST D3DXFONT_DESC * pDesc,LPD3DXFONT * ppFont), 0);
STUB(LONG, RegQueryValueEx, ( HKEY hKey, LPCWSTR lpValueName, LPDWORD lpReserved, LPDWORD lpType, LPBYTE lpData, LPDWORD lpcbData ), 0);
STUB(CMenu*, GetMenu, (), 0);
STUB(BOOL, PeekMessage, (LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg ), 0);
STUB(BOOL , SetConsoleCtrlHandler, (PHANDLER_ROUTINE HandlerRoutine, BOOL Add), 0);
STUB(BOOL, EnumDisplaySettings, (LPCTSTR lpszDeviceName, DWORD iModeNum, LPDEVMODE lpDevMode ), 0);
STUB(HRESULT, D3DXCreateTextureFromFileInMemoryEx, (LPDIRECT3DDEVICE9 pDevice,LPCVOID pSrcData,UINT SrcDataSize,UINT Width,UINT Height,UINT MipLevels,DWORD Usage,D3DFORMAT Format,D3DPOOL Pool,DWORD Filter,DWORD MipFilter,D3DCOLOR ColorKey,D3DXIMAGE_INFO * pSrcInfo,PALETTEENTRY * pPalette,LPDIRECT3DTEXTURE9 * ppTexture), 0);
STUB(SHORT, GetAsyncKeyState, ( int vKey ), 0);
STUB(ATOM, RegisterClass, (const WNDCLASS* lpWndClass), 0);
STUB(BOOL, GetIconInfo, ( HICON hIcon, PICONINFO piconinfo), 0);
STUB(HANDLE, SetClipboardData, (UINT uFormat, HANDLE hMem), 0);
STUB(LONG, SetWindowLong, ( HWND hWnd, int nIndex, LONG dwNewLong), 0);
STUB(UINT, GetKeyboardLayoutList, ( int nBuff, HKL* lpList ), 0);
STUB(BOOL, OpenClipboard, (HWND hWndNewOwner), 0);
STUB(HRESULT, D3DXCreateCubeTextureFromFileEx, (LPDIRECT3DDEVICE9 pDevice,LPCTSTR pSrcFile,UINT Size,UINT MipLevels,DWORD Usage,D3DFORMAT Format,D3DPOOL Pool,DWORD Filter,DWORD MipFilter,D3DCOLOR ColorKey,D3DXIMAGE_INFO * pSrcInfo,PALETTEENTRY * pPalette,LPDIRECT3DCUBETEXTURE9 * ppCubeTexture), 0);
STUB(HKL, GetKeyboardLayout, (DWORD idThread), 0);
STUB(BOOL, SetCurrentDirectory, (LPCTSTR lpPathName), 0);
STUB(D3DXMATRIX *, D3DXMatrixMultiply, (D3DXMATRIX * pOut,CONST D3DXMATRIX * pM1,CONST D3DXMATRIX * pM2), 0);
STUB(BOOL, InflateRect, (LPRECT lprc, int dx, int dy), 0);
STUB(HWND, CreateWindowEx, (DWORD dwExStyle, LPCTSTR lpClassName, LPCTSTR lpWindowName, DWORD dwStyle, int x, int y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam ), 0);
STUB(int, ReleaseDC, (HWND hWnd, HDC hDC), 0);
STUB(LONG, GetWindowLong, ( HWND hWnd, int nIndex), 0);
STUB(BOOL, DeleteObject, (HGDIOBJ hObject), 0);
STUB(HRESULT, D3DXCreateEffectFromResource, (LPDIRECT3DDEVICE9 pDevice,HMODULE hSrcModule,LPCTSTR pSrcResource,CONST D3DXMACRO * pDefines,LPD3DXINCLUDE pInclude,DWORD Flags,LPD3DXEFFECTPOOL pPool,LPD3DXEFFECT * ppEffect,LPD3DXBUFFER * ppCompilationErrors), 0);
STUB(BOOL, ReleaseCapture, (), 0);
STUB(BOOL, EmptyClipboard, (), 0);
STUB(HMODULE , LoadLibrary, (LPCTSTR lpFileName), 0);
STUB(LRESULT, DefWindowProc, ( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam ), 0);
STUB(BOOL, GetVersionEx, (LPOSVERSIONINFO lpVersionInfo), 0);
STUB(HANDLE, GetClipboardData, (UINT uFormat), 0);
STUB(int, GetSystemMetrics, (int nIndex), 0);
STUB(BOOL, DeleteDC, (HDC hdc), 0);
STUB(HRESULT, D3DXCreateEffectFromFile, (LPDIRECT3DDEVICE9 pDevice,LPCTSTR pSrcFile,CONST D3DXMACRO * pDefines,LPD3DXINCLUDE pInclude,DWORD Flags,LPD3DXEFFECTPOOL pPool,LPD3DXEFFECT * ppEffect,LPD3DXBUFFER * ppCompilationErrors), 0);
STUB(HWND, SetCapture, (HWND hWnd ), 0);
STUB(D3DXMATRIX *, D3DXMatrixRotationX, (D3DXMATRIX * pOut,FLOAT Angle), 0);
STUB(int, GetObject, (HGDIOBJ hgdiobj, int cbBuffer, LPVOID lpvObject), 0);
STUB(BOOL, EndDialog, ( HWND hDlg, int nResult), 0);
STUB(HANDLE, GetProcessHeap, (), 0);
STUB(DWORD, GetClassLong, ( HWND hWnd, int nIndex), 0);
STUB(DWORD, ExpandEnvironmentStrings, (LPCTSTR lpSrc, LPTSTR lpDst, DWORD nSize), 0);
STUB(BOOL, SetWindowText, ( HWND hWnd, LPCTSTR lpString ), 0);
STUB(BOOL, HeapValidate, (HANDLE hHeap, DWORD dwFlags, LPCVOID lpMem), 0);
STUB(D3DXMATRIX *, D3DXMatrixScaling, (D3DXMATRIX * pOut,FLOAT sx,FLOAT sy,FLOAT sz), 0);
STUB(BOOL, ScreenToClient, (HWND hWnd, LPPOINT lpPoint), 0);
STUB(LPVOID, GlobalLock, (HGLOBAL hMem), 0);
STUB(BOOL, PostMessage, (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam ), 0);
STUB(HDC, CreateCompatibleDC, (HDC hdc), 0);
STUB(BOOL , GetProcessAffinityMask, (HANDLE hProcess, PDWORD_PTR lpProcessAffinityMask, PDWORD_PTR lpSystemAffinityMask), 0);
STUB(BOOL, DestroyMenu, (HMENU hMenu ), 0);
STUB(BOOL, D3DXCheckVersion, (UINT D3DSDKVersion,UINT D3DXSDKVersion), 0);
STUB(BOOL, DestroyAcceleratorTable, (HACCEL hAccel), 0);
STUB(HCURSOR, LoadCursor, ( HINSTANCE hInstance, LPCTSTR lpCursorName), 0);
STUB(HICON, LoadIcon, (HINSTANCE hInstance, LPCTSTR lpIconName), 0);
STUB(HRESULT, D3DXCreateVolumeTextureFromResourceEx, (LPDIRECT3DDEVICE9 pDevice,HMODULE hSrcModule,LPCTSTR pSrcResource,UINT Width,UINT Height,UINT Depth,UINT MipLevels,DWORD Usage,D3DFORMAT Format,D3DPOOL Pool,DWORD Filter,DWORD MipFilter,D3DCOLOR ColorKey,D3DXIMAGE_INFO * pSrcInfo,PALETTEENTRY * pPalette,LPDIRECT3DVOLUMETEXTURE9 * ppVolumeTexture), 0);
STUB(BOOL, GetCursorPos, ( LPPOINT lpPoint), 0);
STUB(UINT, GetCaretBlinkTime, (), 0);
STUB(BOOL, IntersectRect, (LPRECT lprcDst, CONST RECT *lprcSrc1, CONST RECT *lprcSrc2), 0);
STUB(D3DXMATRIX *, D3DXMatrixPerspectiveFovLH, (D3DXMATRIX * pOut,FLOAT fovy,FLOAT Aspect,FLOAT zn,FLOAT zf), 0);
STUB(BOOL, GetMessage, (LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax ), 0);
STUB(HGLOBAL, GlobalFree, (HGLOBAL hMem), 0);
STUB(HRESULT, D3DXCreateTextureFromFile, (LPDIRECT3DDEVICE9 pDevice,LPCTSTR pSrcFile,LPDIRECT3DTEXTURE9 * ppTexture), 0);
STUB(BOOL, GlobalUnlock, (HGLOBAL hMem), 0);
STUB(HGLOBAL, GlobalAlloc, (UINT uFlags, SIZE_T dwBytes), 0);
STUB(HRESULT, D3DXCreateLine, (LPDIRECT3DDEVICE9 pDevice,LPD3DXLINE* ppLine), 0);
STUB(HRESULT, D3DXLoadMeshFromXInMemory, (LPCVOID Memory,DWORD SizeOfMemory,DWORD Options,LPDIRECT3DDEVICE9 pD3DDevice,LPD3DXBUFFER * ppAdjacency,LPD3DXBUFFER * ppMaterials,LPD3DXBUFFER * ppEffectInstances,DWORD * pNumMaterials,LPD3DXMESH * ppMesh), 0);
STUB(DWORD, GetCurrentDirectoryW, (DWORD nBufferLength,LPWSTR lpBuffer), 0);;
STUB(BOOL, SetRectEmpty, (LPRECT lprc), 0);
STUB(LPTSTR , GetCommandLine, (), 0);
STUB(HRESULT, D3DXCreateTextureFromFileEx, (LPDIRECT3DDEVICE9 pDevice,LPCTSTR pSrcFile,UINT Width,UINT Height,UINT MipLevels,DWORD Usage,D3DFORMAT Format,D3DPOOL Pool,DWORD Filter,DWORD MipFilter,D3DCOLOR ColorKey,D3DXIMAGE_INFO * pSrcInfo,PALETTEENTRY * pPalette,LPDIRECT3DTEXTURE9 * ppTexture), 0);
STUB(D3DXMATRIX *, D3DXMatrixTranslation, (D3DXMATRIX * pOut,FLOAT x,FLOAT y,FLOAT z), 0);
STUB(LONG, DispatchMessage, (const MSG* lpmsg ), 0);
STUB(HRESULT, D3DXCreateEffect, (LPDIRECT3DDEVICE9 pDevice,LPCVOID pSrcData,UINT SrcDataLen,CONST D3DXMACRO * pDefines,LPD3DXINCLUDE pInclude,DWORD Flags,LPD3DXEFFECTPOOL pPool,LPD3DXEFFECT * ppEffect,LPD3DXBUFFER * ppCompilationErrors), 0);
STUB(BOOL, SystemParametersInfo, (UINT uiAction, UINT uiParam, PVOID pvParam, UINT fWinIni), 0);
STUB(D3DXVECTOR3 *, D3DXVec3TransformCoord, (D3DXVECTOR3 * pOut,CONST D3DXVECTOR3 * pV,CONST D3DXMATRIX * pM), 0);
STUB(BOOL, PtInRect, (CONST RECT *lprc, POINT pt), 0);
STUB(BOOL, IsWindowVisible, (HWND hWnd ), 0);
STUB(HRESULT, D3DXAssembleShaderFromFile, (LPCTSTR pSrcFile,CONST D3DXMACRO* pDefines,LPD3DXINCLUDE pInclude,DWORD Flags,LPD3DXBUFFER* ppShader,LPD3DXBUFFER * ppErrorMsgs), 0);
STUB(BOOL, SetCursorPos, ( int x, int y), 0);
STUB(D3DXQUATERNION*, D3DXQuaternionMultiply, ( D3DXQUATERNION* pOut, CONST D3DXQUATERNION* pQ1, CONST D3DXQUATERNION* pQ2), 0);
STUB(BOOL, SystemParametersInfo, (UINT uiAction, UINT uiParam, PVOID pvParam, UINT fWinIni), 0);
STUB(HDC, GetDC, (HWND hWnd), 0);
STUB(HRESULT, GetFocus, (ITfDocumentMgr** ppdimFocus), 0);
STUB(HMODULE, GetModuleHandle, (LPCTSTR lpModuleName), 0);
STUB(EXECUTION_STATE, SetThreadExecutionState, (EXECUTION_STATE esFlags), 0);
STUB(D3DXMATRIX *, D3DXMatrixTranspose, (D3DXMATRIX * pOut,CONST D3DXMATRIX * pM), 0);
STUB(HGDIOBJ, SelectObject, (HDC hdc, HGDIOBJ hgdiobj), 0);
STUB(HRESULT, D3DXCreateVolumeTextureFromFileEx, (LPDIRECT3DDEVICE9 pDevice,LPCTSTR pSrcFile,UINT Width,UINT Height,UINT Depth,UINT MipLevels,DWORD Usage,D3DFORMAT Format,D3DPOOL Pool,DWORD Filter,DWORD MipFilter,D3DCOLOR ColorKey,D3DXIMAGE_INFO * pSrcInfo,PALETTEENTRY * pPalette,LPDIRECT3DVOLUMETEXTURE9 * ppTexture), 0);
STUB(BOOL, EnableWindow, ( HWND hWnd, BOOL bEnable), 0);
STUB(HWND, GetDlgItem, ( HWND hDlg, int nIDDlgItem), 0);
STUB(HCURSOR, SetCursor, (HCURSOR hCursor), 0);
STUB(BOOL, SetMenu, ( CMenu* pMenu), 0);
STUB(D3DXVECTOR3 *, D3DXVec3Normalize, (D3DXVECTOR3 * pOut,CONST D3DXVECTOR3 * pV), 0);
STUB(int, TranslateAccelerator, (HWND hWnd, HACCEL hAccTable, LPMSG lpMsg ), 0);
*/

VSTUB(DebugBreak, ());
VSTUB(PostQuitMessage, (int nExitCode ));
VSTUB(keybd_event, ( BYTE bVk, BYTE bScan, DWORD dwFlags, DWORD dwExtraInfo ));
VSTUB(OutputDebugString, (LPCTSTR lpOutputString));
VSTUB(RtlUnwind, (PVOID TargetFrame, PVOID TargetIp, PEXCEPTION_RECORD ExceptionRecord, PVOID ReturnValue));
