/*
 *  Kernel32.h
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#ifndef __ALKY_KERNEL32_H__
#define __ALKY_KERNEL32_H__

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>
#include <sys/times.h>
#include <errno.h>

#include "Common/alky.h"

typedef struct Heap_s {
  DWORD curSize, maxSize;
  void *loc;
  int count;
  void *ptrs[256];
  DWORD sizes[256];
} Heap;

typedef struct _OSVERSIONINFO {
  DWORD dwOSVersionInfoSize;
  DWORD dwMajorVersion;
  DWORD dwMinorVersion;
  DWORD dwBuildNumber;
  DWORD dwPlatformId;
  TCHAR szCSDVersion[128];
} OSVERSIONINFO,
*LPOSVERSIONINFOA;

typedef OSVERSIONINFO *LPOSVERSIONINFO;
typedef void *(*PFLS_CALLBACK_FUNCTION)(DWORD index);

enum {
  FILE_TYPE_UNKNOWN = 0,
  FILE_TYPE_DISK = 1,
  FILE_TYPE_CHAR = 2,
  FILE_TYPE_PIPE = 3,
  FILE_TYPE_REMOTE = 4
} FILE_TYPES;


#endif
