/*
 *  Kernel32_Env.c
 *  LibAlky
 *
 *  Created by Matt Barnard on 6/15/06.
 *  Copyright 2006 Matt Barnard.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "Kernel32.h"


// defined by MSDN as LPVOID, not LPCSTR, and as GetEnvironmentStringsA.
ALKYAPI LPCSTR GetEnvironmentStrings_W32() {
  AlkyLog("GetEnvironmentStringsA called");

  return (LPCSTR) environ;
}

// this is also defined by MSDN as returning LPVOID, but the STUB said LPWSTR.
ALKYAPI LPWSTR GetEnvironmentStringsW_W32() {
  AlkyLog( "GetEnvironmentStringsW called" );
  return (LPWSTR) environ;
}

ALKYAPI BOOL FreeEnvironmentStringsA_W32(LPSTR lpszEnvironmentBlock) {
  AlkyLog("FreeEnvironmentStringsA called");
  return 1;
}

ALKYAPI BOOL FreeEnvironmentStringsW_W32( LPCTSTR lpName, LPCSTR lpBuffer, DWORD nSize ) {
  AlkyLog( "FreeEnvironmentStringsW callled" );
  return 1;
}

ALKYAPI DWORD GetEnvironmentVariableA_W32(LPCTSTR lpName, LPCSTR lpBuffer, DWORD nSize) {
  char *temp;
  
  AlkyLog("GetEnvironmentVariableA called");
  
  temp = getenv((char *) lpName);
  
  strncpy((char *) lpBuffer, temp, nSize);
  
  return 1;
}


STUB(BOOL, SetEnvironmentVariableA, (LPCSTR lpName,LPCSTR lpValue), 0);

// STUB(LPCSTR, GetEnvironmentStrings, (), 0);
// STUB(LPWSTR, GetEnvironmentStringsW, (), 0);
// STUB(BOOL, FreeEnvironmentStringsW, (LPWSTR lpszEnvironmentBlock), 0);
// STUB(BOOL, FreeEnvironmentStringsA, (LPSTR lpszEnvironmentBlock), 0);