/*
 *  Kernel32_FlsTls.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/14/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "Kernel32.h"

#define MAX_TLS_FLS 1088

void *tls_a[MAX_TLS_FLS];
char tls_f[MAX_TLS_FLS];

ALKYAPI DWORD TlsAlloc_W32() {
  int i;
  
  AlkyLog("TlsAlloc called");
  
  for(i = 0; i < MAX_TLS_FLS; ++i) {
    if(tls_f[i] == 0)
      break;
  }
  
  tls_a[i] = 0;
  tls_f[i] = 1;
  
  return (DWORD) i++;
}

ALKYAPI PVOID TlsGetValue_W32(DWORD dwTlsIndex) {
  AlkyLog("TlsGetValue called.  %i %p", dwTlsIndex, tls_a[dwTlsIndex]);
  
  if(dwTlsIndex < MAX_TLS_FLS)
     return tls_a[dwTlsIndex];
  else
     return 0;
}

ALKYAPI BOOL TlsSetValue_W32(DWORD dwTlsIndex, PVOID lpTlsData) {
  AlkyLog("TlsSetValue called");
  AlkyLog("TLS index %p == %p", tls_a[dwTlsIndex], lpTlsData);
  
  if(dwTlsIndex < MAX_TLS_FLS)
    tls_a[dwTlsIndex] = lpTlsData;
  else
    return 0;

  return 1;
}

ALKYAPI BOOL TlsFree_W32(DWORD dwTlsIndex) {
  AlkyLog("TlsFree called");
  
  if(dwTlsIndex < MAX_TLS_FLS)
    tls_f[dwTlsIndex] = 0;
  else
    return 0;
  
  return 1;
}

// STUB(DWORD, FlsAlloc, (PFLS_CALLBACK_FUNCTION lpCallback), 0);
// STUB(PVOID, FlsGetValue, (DWORD dwFlsIndex), 0);
// STUB(BOOL, FlsSetValue, (DWORD dwFlsIndex, PVOID lpFlsData), 0);
// STUB(BOOL, FlsFree, (DWORD dwFlsIndex), 0);

// STUB(DWORD, TlsAlloc, (), 0);
// STUB(BOOL, TlsFree, (DWORD dwTlsIndex), 0);
// STUB(BOOL, TlsSetValue, (DWORD dwTlsIndex,LPVOID lpTlsValue), 0);
// STUB(LPVOID, TlsGetValue, (DWORD dwTlsIndex), 0);
