/*
 *  Kernel32_Locale.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/15/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "Kernel32.h"

#define IBM_EBCDIC 37
#define OEM_CP 437

// IBM EBCDIC - U.S./Canada
UINT GetACP() {
  AlkyLog( "GetACP called" );
  return IBM_EBCDIC;
}

// OEM - United States
UINT GetOEMCP() {
  AlkyLog( "GetOEMCP called" );
  return OEM_CP;
}

STUB(BOOL, SystemTimeToTzSpecificLocalTime, (LPTIME_ZONE_INFORMATION lpTimeZoneInformation,LPSYSTEMTIME lpUniversalTime,LPSYSTEMTIME lpLocalTime), 0);
STUB(DWORD, GetTimeZoneInformation, (LPTIME_ZONE_INFORMATION lpTimeZoneInformation), 0);
STUB(int, GetLocaleInfoW, (LCID Locale,LCTYPE LCType,LPWSTR lpLCData,int cchData), 0);
STUB(BOOL, IsValidLocale, (LCID Locale,DWORD dwFlags), 0);
STUB(BOOL, EnumSystemLocalesA, (LOCALE_ENUMPROCA lpLocaleEnumProc,DWORD dwFlags), 0);
STUB(int, GetLocaleInfoA, (LCID Locale,LCTYPE LCType,LPSTR lpLCData,int cchData), 0);
STUB(LCID, GetUserDefaultLCID, (), 0);
VSTUB(GetLocalTime, (LPSYSTEMTIME lpSystemTime));

// STUB(UINT, GetACP, (), 37);
// STUB(UINT, GetOEMCP, (), 437);