/*
 *  Kernel32_Memory.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/15/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "Kernel32.h"

ALKYAPI LPVOID VirtualAlloc_W32(LPVOID lpAddress,DWORD dwSize,DWORD flAllocationType,DWORD flProtect) {
  AlkyLog("VirtualAlloc called");
  
  return malloc(dwSize);
}

ALKYAPI void GlobalMemoryStatus_W32(LPMEMORYSTATUS lpBuffer) {
  AlkyLog("GlobalMemoryStatus called");
  
  memset(lpBuffer, 0, sizeof(MEMORYSTATUS));
  
  lpBuffer->dwLength = sizeof(MEMORYSTATUS);
  lpBuffer->dwMemoryLoad = 0x1000;
  lpBuffer->dwTotalPhys = 1*1024*1024*1024; // 1GB RAM FTW!
  lpBuffer->dwAvailPhys = lpBuffer->dwTotalPhys - 0x1000;
  lpBuffer->dwTotalVirtual = lpBuffer->dwTotalPhys;
  lpBuffer->dwAvailVirtual = lpBuffer->dwTotalPhys - 0x1000;
}

ALKYAPI BOOL GetCPInfo_W32(UINT CodePage, LPCPINFO lpCPInfo) {
  int i;
  
  AlkyLog("GetCPInfo called");
  
  lpCPInfo->MaxCharSize = 1;
  lpCPInfo->DefaultChar[0] = ' ';
  lpCPInfo->DefaultChar[1] = 0;
  for(i = 0; i < MAX_LEADBYTES; ++i)
    lpCPInfo->LeadByte[i] = 0;
  return 1;
}

STUB(HLOCAL, LocalFree, (HLOCAL hMem), 0);
STUB(BOOL, IsBadReadPtr, (const void *lp,UINT ucb), 0);
STUB(BOOL, IsBadWritePtr, (LPVOID lp,UINT ucb), 0);
STUB(DWORD, VirtualQuery, (LPCVOID lpAddress,PMEMORY_BASIC_INFORMATION lpBuffer,DWORD dwLength), 0);
STUB(BOOL, VirtualProtect, (LPVOID lpAddress,DWORD dwSize,DWORD flNewProtect,PDWORD lpflOldProtect), 0);
STUB(BOOL, IsBadCodePtr, (FARPROC lpfn), 0);
STUB(BOOL, IsValidCodePage, (UINT CodePage), 0);
STUB(BOOL, VirtualFree, (LPVOID lpAddress,DWORD dwSize,DWORD dwFreeType), 0);

// STUB(BOOL, GetCPInfo, (UINT CodePage, LPCPINFO lpCPInfo), 0);
// STUB(LPVOID, VirtualAlloc, (LPVOID lpAddress,DWORD dwSize,DWORD flAllocationType,DWORD flProtect), 0);
// VSTUB(GlobalMemoryStatus, (LPMEMORYSTATUS lpBuffer));
