/*
 *  Kernel32_Misc.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/14/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "Kernel32.h"

ALKYAPI BOOL GetVersionExA_W32(LPOSVERSIONINFO lpVersionInfo) {
  AlkyLog("GetVersionExA called");
  
  lpVersionInfo = (LPOSVERSIONINFO) malloc(sizeof(OSVERSIONINFO));
  
  lpVersionInfo->dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  lpVersionInfo->dwMajorVersion = 5;
  lpVersionInfo->dwMinorVersion = 1;
  lpVersionInfo->dwBuildNumber = 0;
  lpVersionInfo->dwPlatformId = 2;
  memset(lpVersionInfo->szCSDVersion, 0, 128);
  strcpy((char *) lpVersionInfo->szCSDVersion, (char *) "Alky!");
  return 1;
}

// GetVersion is 16-bit. Superceded by GetVersionEx in all 32-bit instances
// included just because. Returns WINNT
ALKYAPI DWORD GetVersion_W32() {
	AlkyLog( "GetVersion called" );
	return 0x4000;
}

ALKYAPI void ExitProcess_W32(UINT uExitCode) {
  AlkyLog("ExitProcess called");
  exit(uExitCode);
}

ALKYAPI void GetStartupInfoA_W32(LPSTARTUPINFOA lpStartupInfo) {
  AlkyLog("GetStartupInfoA called");
  
  memset(lpStartupInfo, 0, sizeof(STARTUPINFO));
  lpStartupInfo->cb = sizeof(STARTUPINFO);
}

ALKYAPI LPSTR GetCommandLineA_W32() {
  char *ret;
  int i, off = 0;
  
  AlkyLog("GetCommandLineA called");
  
  ret = (char *) malloc(256);
  
  for(i = 0; i < argc; ++i) {
    if(off+strlen(argv[i]) > 254)
      break;
    strcpy(ret+off, argv[i]);
    off += strlen(argv[i]) + 1;
    ret[off - 1] = ' ';
  }
  ret[off - 1] = 0;
  
  return (LPSTR) ret;
}

// TODO: should be unicode!!
ALKYAPI LPSTR GetCommandLineW_W32() {
  AlkyLog( "(UNIMPLEMENTED UNICODE) GetCommandLineW called" );
  return GetCommandLineA_W32();
}

ALKYAPI BOOL IsProcessorFeaturePresent_W32(DWORD ProcessorFeature) {
  AlkyLog("IsProcessorFeaturePresent called");
  
  return 1;
}

// TODO: this function returns a LOT of very specific parameters.
// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/systemparametersinfo.asp
// for list of infos it can return. Too many specific things to implement, stuff like desktop background.
ALKYAPI BOOL SystemParametersInfoW( UINT uiAction, UINT uiParam, PVOID pvParam, UINT fWinIni ) {
  return 1;
}

// default behavior on windows is to return the number of ticks since boot,
// but on linux/bsd(mac) it returns the number of ticks since arbitrary date,
// this probably won't cause any problems.
ALKYAPI DWORD GetTickCount() {
  AlkyLog( "GetTickCount called" );
  struct tms t;
  return times( &t );
}


STUB(BOOL, QueryPerformanceCounter, (LARGE_INTEGER *lpPerformanceCount), 0);
STUB(BOOL, QueryPerformanceFrequency, (LARGE_INTEGER *lpFrequency), 0);
VSTUB(GetSystemInfo, (LPSYSTEM_INFO lpSystemInfo));
VSTUB(GetSystemTimeAsFileTime, (LPFILETIME lpSystemTimeAsFileTime));
STUB(BOOL, CloseHandle, (HANDLE hObject), 0);

// STUB(DWORD, GetTickCount, (), 0);
// STUB(DWORD, GetVersion, (), 0x00000000);
// STUB(BOOL, GetVersionExA, (LPOSVERSIONINFOA lpVersionInformation), 0);
// STUB(LPSTR, GetCommandLineA, (), (LPSTR) "Oblivion.exe");
// VSTUB(GetStartupInfoA, (LPSTARTUPINFOA lpStartupInfo));
// STUB(BOOL, SystemParametersInfoW, (UINT uiAction, UINT uiParam, PVOID pvParam, UINT fWinIni), 0);
     