/*
 *  Kernel32_Modules.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/14/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "Kernel32.h"

ALKYAPI HMODULE GetModuleHandleA_W32(LPCTSTR lpModuleName) {
  AlkyLog("GetModuleHandleA called");
  printf("lpModuleName: %s\n", lpModuleName);
  
  if(lpModuleName == 0) {
    FILE *fp;
    int i;
    char *file;
    char fname_[256];
    char *fname;
    
    fname = fname_;
    
    printf("%s\n", getcwd());
    snprintf(fname, 255, "%s.exe", argv[0]);
    
    for(i = 0; i < 256, fname_[i] != 0; ++i) {
      if(fname_[i] == '/')
        fname = &fname_[i + 1];
    }
    
    fp = fopen(fname, "rb");
    
    fseek(fp, 0, 2);
    i = ftell(fp);
    fseek(fp, 0, 0);
    file = (char *) malloc(i);
    fread(file, 1, i, fp);
    fclose(fp);
    
    return (HMODULE) file;
  } else
    return (HMODULE) 0xDEADBEEF;
}

ALKYAPI HMODULE LoadLibraryA_W32(LPCSTR lpLibFileName) {
  AlkyLog("LoadLibraryA called, requesting handle for `%s'", (char *) lpLibFileName);
  
  return (HMODULE) 0xDEADBEEF;
}

ALKYAPI DWORD GetModuleFileNameA_W32(HMODULE hModule,LPSTR lpFilename,DWORD nSize) {
  char *fntemp;
  
  AlkyLog("GetModuleFileNameA called");
  
  if(hModule == 0)
    fntemp = "Oblivion.exe";
  else
    fntemp = "alky.dylib";
  strncpy((char *) lpFilename, (char *) fntemp, nSize);
  return 1;
}

ALKYAPI FARPROC GetProcAddress_W32(HMODULE hModule,LPCSTR lpProcName) {
  void *alkydylib, *ret;
  char procName[256];
  char fname_[256];
  char *fname;
  char fname2[256];
  int i;
  
  AlkyLog("GetProcAddress called");
  printf("lpProcName: %s\n", lpProcName);
  
  fname = fname_;
  
  snprintf(fname, 255, "%s.app", argv[0]);
  
  for(i = 0; i < 256, fname_[i] != 0; ++i) {
    if(fname_[i] == '/')
      fname = &fname_[i + 1];
  }
  
  snprintf(fname2, 255, "%s/Contents/Frameworks/alky.dylib", fname);
  
  alkydylib = dlopen(fname2, RTLD_NOW);
  
  snprintf(procName, 256, "%s_W32", lpProcName);
  ret = dlsym(alkydylib, procName);
  
  if(ret == 0) {
    printf("Not found!\n");
  }
  
  return ret;
}

STUB(BOOL, FreeLibrary, (HMODULE hLibModule), 0);

// STUB(HMODULE, LoadLibraryA, (LPCSTR lpLibFileName), 0);
// STUB(HMODULE, GetModuleHandleA, (LPCSTR lpModuleName), 0);
// STUB(DWORD, GetModuleFileNameA, (HMODULE hModule,LPSTR lpFilename,DWORD nSize), 0);
