/*
 *  User32.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "User32.h"

#ifdef MAC
#include <CoreFoundation/CoreFoundation.h>
#endif

ALKYAPI int MessageBoxA_W32(HWND hWnd,LPCSTR lpText,LPCSTR lpCaption,UINT uType) {
  CFOptionFlags responseFlags;
  
  AlkyLog("MessageBoxA called.  Caption is `%s' and Text is `%s'", lpCaption, lpText);
  
#ifdef MAC
  CFUserNotificationDisplayAlert(0, kCFUserNotificationStopAlertLevel, NULL, NULL, NULL,
                                CFStringCreateWithCString(NULL, (char *) lpCaption, kCFStringEncodingASCII),
                                CFStringCreateWithCString(NULL, (char *) lpText, kCFStringEncodingASCII),
                                NULL, NULL, NULL, &responseFlags);
#endif

#ifdef LINUX
	
#endif

  return 1;
}

STUB(HWND, GetDesktopWindow, (), (HWND) 0xDEADBEEF);
STUB(HBRUSH, GetSysColorBrush, (int nIndex), 0);
STUB(LRESULT, SendMessageA, (HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam), 0);
STUB(BOOL, SwapMouseButton, (BOOL fSwap), 0);
// STUB(int, MessageBoxA, (HWND hWnd,LPCSTR lpText,LPCSTR lpCaption,UINT uType), 1);
STUB(LRESULT, DefWindowProcA, (HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam), 0);
STUB(LONG, DispatchMessageA, (const MSG *lpMsg), 0);
STUB(BOOL, TranslateMessage, (const MSG *lpMsg), 0);
STUB(BOOL, PeekMessageA, (LPMSG lpMsg,HWND hWnd,UINT wMsgFilterMin,UINT wMsgFilterMax,UINT wRemoveMsg), 0);
STUB(DWORD, GetClassLongA, (HWND hWnd,int nIndex), 0);
STUB(LONG, GetWindowLongA, (HWND hWnd,int nIndex), 0);
STUB(BOOL, UpdateWindow, (HWND hWnd), 0);
STUB(HCURSOR, LoadCursorA, (HINSTANCE hInstance,LPCSTR lpCursorName), 0);
STUB(HWND, GetWindow, (HWND hWnd,UINT uCmd), 0);
STUB(BOOL, SetWindowPos, (HWND hWnd,HWND hWndInsertAfter,int X,int Y,int cx,int cy,UINT uFlags), 0);
STUB(BOOL, ShowWindow, (HWND hWnd,int nCmdShow), 0);
STUB(int, ShowCursor, (BOOL bShow), 0);
STUB(BOOL, DestroyWindow, (HWND hWnd), 0);
STUB(BOOL, GetClientRect, (HWND hWnd,LPRECT lpRect), 0);
STUB(HWND, FindWindowA, (LPCSTR lpClassName,LPCSTR lpWindowName), 0);
STUB(BOOL, SetForegroundWindow, (HWND hWnd), 0);
STUB(HICON, LoadIconA, (HINSTANCE hInstance,LPCSTR lpIconName), 0);
STUB(ATOM, RegisterClassA, (const WNDCLASSA *lpWndClass), 0);
STUB(BOOL, AdjustWindowRect, (LPRECT lpRect,DWORD dwStyle,BOOL bMenu), 0);
// STUB(HWND, CreateWindowExA, (DWORD dwExStyle,LPCSTR lpClassName,LPCSTR lpWindowName,DWORD dwStyle,int X,int Y,int nWidth,int nHeight,HWND hWndParent,HMENU hMenu,HINSTANCE hInstance,LPVOID lpParam), 0);
STUB(HWND, GetActiveWindow, (), 0);
STUB(HWND, GetLastActivePopup, (HWND hWnd), 0);
