/*
 *  User32.h
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#ifndef __ALKY_USER32__
#define __ALKY_USER32__

#ifdef MAC
#include <Carbon/Carbon.h>
#endif

#include "Common/alky.h"

typedef DWORD LRESULT;
typedef void *HICON;
typedef void *HMENU;
typedef void *HBRUSH;
typedef void *HCURSOR;
typedef void *WPARAM;
typedef void *LPARAM;
typedef void *WNDPROC;
typedef DWORD ATOM;

typedef struct _HWND {
  ATOM class;
#ifdef MAC
  WindowRef wind;
#endif
} WND, *HWND;

typedef struct _RECT { 
  LONG left; 
  LONG top; 
  LONG right; 
  LONG bottom; 
} RECT, *PRECT, *LPRECT;

typedef struct tagPOINT { 
  LONG x; 
  LONG y; 
} POINT, *PPOINT; 

typedef struct {
  HWND hwnd;
  UINT message;
  WPARAM wParam;
  LPARAM lParam;
  DWORD time;
  POINT pt;
} MSG, *PMSG, *LPMSG;

typedef struct {
  UINT style;
  WNDPROC lpfnWndProc;
  int cbClsExtra;
  int cbWndExtra;
  HINSTANCE hInstance;
  HICON hIcon;
  HCURSOR hCursor;
  HBRUSH hbrBackground;
  LPCTSTR lpszMenuName;
  LPCTSTR lpszClassName;
} WNDCLASSA, *PWNDCLASSA;

typedef struct {
  UINT cbSize;
  UINT style;
  WNDPROC lpfnWndProc;
  int cbClsExtra;
  int cbWndExtra;
  HINSTANCE hInstance;
  HICON hIcon;
  HCURSOR hCursor;
  HBRUSH hbrBackground;
  LPCSTR lpszMenuName;
  LPCSTR lpszClassName;
  HICON hIconSm;
} WNDCLASSEXA, *PWNDCLASSEXA;

#endif
