/*
 *  User32.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "User32.h"

WNDCLASSEXA *_classes[32768];
int _classcount = 0;

ALKYAPI ATOM RegisterClassExA_W32(WNDCLASSEXA *lpwcx) {
  AlkyLog("RegisterClassEx called");
  
  _classes[_classcount] = lpwcx;
  
  return _classcount++;
}

ALKYAPI HWND CreateWindowExA_W32(DWORD dwExStyle,
                     LPCSTR lpClassName,
                     LPCSTR lpWindowName,
                     DWORD dwStyle,
                     int X,int Y,
                     int nWidth,int nHeight,
                     HWND hWndParent,
                     HMENU hMenu,
                     HINSTANCE hInstance,
                     LPVOID lpParam) {
  int i;
  WNDCLASSEXA *class;
  
  AlkyLog("CreateWindowEx called");
  
  // PAD_STACK();
  
  for(i = 0; i < _classcount; ++i) {
    if(strcmp((char *) _classes[i]->lpszClassName, (char *) lpClassName) == 0) {
      break;
    }
  }
  
  if(i == _classcount)
    return NULL;
  
  class = _classes[i];

#ifdef MAC
  {
    WindowAttributes attributes;
    Rect contentBounds;
    WindowRef outWindow;
    OSStatus err;
    
    HWND wind = (HWND) malloc(sizeof(WND));
    
    attributes = kWindowStandardHandlerAttribute |
      kWindowStandardDocumentAttributes;
    
    X = 50;
    Y = 100;
    
    nWidth = 50;
    nHeight = 100;
    
    SetRect(&contentBounds, X, Y,
                            X+nWidth, Y+nHeight);
    
    if((err = CreateNewWindow(kDocumentWindowClass, attributes, &contentBounds, &outWindow)) != noErr) {
      return NULL;
    }
    
    ShowWindow(outWindow);
    
    wind->class = i;
    wind->wind = outWindow;
    
    // UNPAD_STACK();
    
    return wind;
  }
#endif
}
