/*
 *  WSock32.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "WSock32.h"
#include "User32.h"

typedef int SOCKET;

#define W32_FD_SETSIZE      64

int wsaLastError = 0;


typedef struct w32_fd_set {
  UINT fd_count;
  SOCKET fd_array[W32_FD_SETSIZE];
} w32_fd_set;

typedef struct in_addr {
  union {
    struct {
      u_char s_b1,s_b2,s_b3,s_b4;
    } S_un_b;
    struct {
      u_short s_w1,s_w2;
    } S_un_w;
    u_long S_addr;
  } S_un;
} in_addr;

struct sockaddr {
  short   sin_family;
  u_short sin_port;
  struct  in_addr sin_addr;
  char    sin_zero[8];
};

#define WSADESCRIPTION_LEN      256
#define WSASYS_STATUS_LEN       128

typedef struct WSAData_ {
  WORD wVersion;
  WORD wHighVersion;
  char szDescription[WSADESCRIPTION_LEN+1];
  char szSystemStatus[WSASYS_STATUS_LEN+1];
  unsigned short iMaxSockets;
  unsigned short iMaxUdpDg;
  char *lpVendorInfo;
} WSADATA;
typedef WSADATA *LPWSADATA;


// contrary to typical win32 operation, WSAStartup need not be called before these are used.
// but because win32 requires it, it won't be a problem unless someone converts fucked up code
// that wouldn't work anyway.
ALKYAPI int WSAGetLastError() {
  AlkyLog( "WSAGetLastError called" );
  return wsaLastError;
}

ALKYAPI void WSASetLastError( int iError ) {
  AlkyLog( "WSASetLastError called" );
  wsaLastError = iError;
}

// STUB(int, WSAGetLastError, (), 0);
// VSTUB(WSASetLastError, (int iError), 0);
STUB(int, WSAAsyncSelect, (SOCKET s,HWND hWnd,u_int wMsg,__int32 lEvent), 0);
STUB(int, listen, (SOCKET s,int backlog), 0);
STUB(int, bind, (SOCKET s,const struct sockaddr *name,int namelen), 0);
STUB(int, setsockopt, (SOCKET s,int level,int optname,const char *optval,int optlen), 0);
STUB(int, WSAStartup, (WORD wVersionRequested,LPWSADATA lpWSAData), 0);
STUB(SOCKET, accept, (SOCKET s,struct sockaddr *addr,int *addrlen), 0);
STUB(int, __WSAFDIsSet, (SOCKET s, w32_fd_set *fds), 0);
STUB(int, select, (int nfds,w32_fd_set *readfds,w32_fd_set *writefds,w32_fd_set *exceptfds,const struct timeval *timeout), 0);
STUB(unsigned int, inet_addr, (const char *cp), 0);
STUB(struct hostent*, gethostbyname, (const char *name), 0);
STUB(int, connect, (SOCKET s,const struct sockaddr *name,int namelen), 0);
STUB(int, send, (SOCKET s,const char *buf,int len,int flags), 0);
STUB(int, recv, (SOCKET s,char *buf,int len,int flags), 0);
STUB(SOCKET, socket, (int af,int type,int protocol), 0);
STUB(int, closesocket, (SOCKET s), 0);
