/*
 *  WinMM.c
 *  LibAlky
 *
 *  Created by Cody Brocious on 5/13/06.
 *  Copyright 2006 Cody Brocious.  Redistribution terms are in the included LICENSE file.
 *
 */

#include "WinMM.h"

typedef void *HMMIO;
typedef DWORD MMRESULT;
typedef DWORD FOURCC;
typedef unsigned char *HPSTR;
typedef void *HTASK;
typedef void *LPMMIOPROC;

typedef struct { 
  FOURCC ckid; 
  DWORD  cksize; 
  FOURCC fccType; 
  DWORD  dwDataOffset; 
  DWORD  dwFlags; 
} MMCKINFO,
*LPMMCKINFO;

typedef struct { 
  DWORD      dwFlags; 
  FOURCC     fccIOProc; 
  LPMMIOPROC pIOProc; 
  UINT       wErrorRet; 
  HTASK      hTask; 
  LONG       cchBuffer; 
  HPSTR      pchBuffer; 
  HPSTR      pchNext; 
  HPSTR      pchEndRead; 
  HPSTR      pchEndWrite; 
  LONG       lBufOffset; 
  LONG       lDiskOffset; 
  DWORD      adwInfo[4]; 
  DWORD      dwReserved1; 
  DWORD      dwReserved2; 
  HMMIO      hmmio; 
} MMIOINFO,
*LPMMIOINFO;

STUB(MMRESULT, mmioAscend, (HMMIO hmmio,LPMMCKINFO pmmcki,UINT fuAscend), 0);
STUB(LONG, mmioRead, (HMMIO hmmio,HPSTR pch,LONG cch), 0);
STUB(MMRESULT, mmioClose, (HMMIO hmmio,UINT fuClose), 0);
STUB(MMRESULT, mmioAdvance, (HMMIO hmmio,LPMMIOINFO pmmioinfo,UINT fuAdvance), 0);
STUB(MMRESULT, mmioGetInfo, (HMMIO hmmio,LPMMIOINFO pmmioinfo,UINT fuInfo), 0);
STUB(HMMIO, mmioOpenA, (LPSTR pszFileName,LPMMIOINFO pmmioinfo,DWORD fdwOpen), 0);
STUB(MMRESULT, mmioDescend, (HMMIO hmmio,LPMMCKINFO pmmcki,const MMCKINFO *pmmckiParent,UINT fuDescend), 0);
