import urllib2, re

item_re = re.compile('<item>(.*?)</item', re.M|re.I|re.S)
title_re = re.compile('<title>(.*?)</title>', re.M|re.I|re.S)
link_re = re.compile('<link>(.*?)</link>', re.M|re.I|re.S)
proto_re = re.compile('<PRE CLASS=.*?syntax.*?>(.*?)</PRE>', re.M|re.I|re.S)

fraRight_re = re.compile('<FRAME name="fraRightFrame" src="(.*?)"', re.M|re.I|re.S)
fraContent_re = re.compile('<FRAME name="fraContent" src="(.*?)"', re.M|re.I|re.S)

clean_re = re.compile('<.*?>')

def getData(url):
    request = urllib2.Request(url)
    request.add_header('User-Agent', 'Googlebot/2.1')
    return urllib2.urlopen(request).read()

def parseFrames(data):
    sea = re.search(fraRight_re, data)
    if sea == None:
        sea = re.search(fraContent_re, data)
        if sea == None:
            return data

    url = sea.group(1)
    if url[0] == '/':
        url = 'http://msdn.microsoft.com' + url

    return parseFrames(getData(url))

def stripComment(data):
    d = []
    for line in data.split('\n'):
        if '//' in line:
          line = line.split('//')[0]
        d.append(line.strip())
    return '\n'.join(d)

def getPrototype(name):
    if name[-1] == 'A' or name[-1] == 'W':
        name = name[:-1]
        
    url = 'http://search.msdn.microsoft.com/search/data.ashx?tab=0&siteid=0&query=' + name
    try:
        data = getData(url)
    except:
        return name

    try:
        items = re.findall(item_re, data)

        for item in items:
            title = re.search(title_re, item).group(1)
            link = re.search(link_re, item).group(1)
            if not name in title:
                continue

            try:
                data = getData(link)

                data = stripComment(data)

                data = parseFrames(data)

                proto = re.search(proto_re, data)
                proto = proto.group(1)

                proto = re.sub(clean_re, '', proto)
                
                proto = proto.replace('&nbsp;', ' ')

                proto = proto.replace('\r', '')
                proto = proto.replace('\n', '')

                while '  ' in proto:
                    proto = proto.replace('  ', ' ')
                    
                return proto
            except:
                continue
    except:
        pass

    return name
