#!/usr/bin/env python

import sys, os

import convert
from proto import getPrototype

def main(args):
    noCompile = False
    doLookup = False

    while True:
        if args[0] == '--fake':
            noCompile = True
            args = args[1:]
        elif args[0] == '--lookup':
            doLookup = True
            args = args[1:]
        else:
            break
    
    inn = args[0]
    name = args[0].split('.')[0]

    os.system('./get_functions.sh ../LibAlky')

    supported = file('functions.txt', 'r').read().split('\n')
    exceptions = file('exceptions.txt', 'r').read().split('\n')

    os.system('mkdir temp')

    conv = convert.Convertor(inn, 'temp/' + name)

    file('temp/%s.c' % name, 'w').write(file('linkwrapper.c').read().replace('%APPNAME%', name).replace('%ENTRYPOINT%', hex(conv.entry)))

    tfp = file('temp/%s_thunk.h' % name, 'w')
    usfp = file('unsupported.txt', 'w')

    for tname in conv.thunk:
        if not tname:
            continue
        tname_ = tname.split('@')[0]
        if tname_[0] == '_':
            tname_ = tname_[1:]
        if not tname_ in supported and not conv.thunk[tname][0] in exceptions:
            if doLookup:
                proto = getPrototype(tname_)
            else:
                proto = tname_
            usfp.write(proto + '\n')
            print 'Unsupported function %s used from %s' % (proto, conv.thunk[tname][0])
        tfp.write('THUNK(0x%08X, %s_W32);\n' % (conv.thunk[tname][1], tname_))

    tfp.close()
    usfp.close()

    if noCompile:
        return -1

    comp = 'gcc -o temp/%s.o temp/%s.c -c' % (name, name)
    if os.system(comp) != 0:
        print 'Compiling linkwrapper failed'
        return -1

    ld = []
    ld.append('ld -e start')

    for segname in conv.mo.segments:
        ld.append('-segaddr %s 0x%08X' % (segname, conv.mo.segments[segname].vmaddr))
    
    ld.append('-o temp/%s.mac' % name)
    ld.append('-execute temp/%s.o' % name)
    ld.append('/Developer/SDKs/MacOSX10.4u.sdk/usr/lib/libSystem.dylib')
    ld.append('/Developer/SDKs/MacOSX10.4u.sdk/usr/lib/crt1.o')
    ld.append('temp/' + name)

    if os.system(' '.join(ld)) != 0:
        print 'Linking wrapper failed'
        return -1

    os.system('mkdir -p %s.app/Contents/MacOS' % name)
    os.system('mkdir -p %s.app/Contents/Frameworks' % name)
    os.system('cp -f temp/%s.mac %s.app/Contents/MacOS/%s' % (name, name, name))
    os.system('cp -f ../LibAlky/Build/libalky.dylib %s.app/Contents/Frameworks/alky.dylib' % name)
    file('%s.app/Contents/Info.plist' % name, 'w').write(file('Info_Boilerplate.plist').read().replace('%APPNAME%', name))

    # os.chdir('%s.app/Contents/MacOS' % name)
    # os.system('./%s' % name)

if __name__=='__main__':
    sys.exit(main(sys.argv[1:]))
